// 002 u_packet_format
// 22 nov 2004

//.no_cr

// -- Conversion of BPF.H
// -- the driver places the packets in a +- unix envelope "bpf"

(*$r+*)

unit u_packet_format;
  interface
    Type Tbpf_u_int32= LongWord;

         // -- unix timestamp
         PunixTimeVal= ^TunixTimeVal;
         TunixTimeVal= record
                         tv_Sec, // Secs since 1/1/1970
                         tv_uSec: LongWord; // microseconds
                       end;

         // -- Structure prepended to each packet.
         Pbpf_hdr= ^Tbpf_hdr;
         Tbpf_hdr= record
                     bh_tstamp: TunixTimeval; // time stamp
                     bh_caplen, // length of captured portion
                     bh_datalen: Tbpf_u_int32; // original length of packet
                     bh_hdrlen: Word; // length of bpf header (this struct plus alignment padding)
                   end;

    // -- Force data to be aligned
    type Tbpf_int32= Integer;
    const BPF_ALIGNMENT= sizeof(Tbpf_int32);
    Function BPF_WORDALIGN(X: LongWord): LongWord;

  implementation

    function BPF_WORDALIGN(X: LongWord): LongWord;
        // This was originally a C macro :
        // #define BPF_WORDALIGN(x) (((x)+(BPF_ALIGNMENT-1))&~(BPF_ALIGNMENT-1))
      begin
        result:= (((X)+ (BPF_ALIGNMENT- 1)) and not (BPF_ALIGNMENT- 1));
      end; // BPF_WORDALIGN

    end.
