// 004 u_ethernet_packet
// 10 dec 2004

// -- (C) Felix John COLIBRI 2004
// -- documentation: http://www.felix-colibri.com

(*$r+*)

unit u_ethernet_packet;
  interface
    uses u_sniffer_utils;
    const k_reception= 'i';
          k_emission= 'o';
          k_no_direction= '?';

    type t_ethernet_packet= packed record
                                m_ethernet_destination: t_MAC_address;
                                m_ethernet_source: t_MAC_address;
                                m_ethernet_protocol: array[0..1] of byte;
                                // -- variable size
                                m_ethernet_data: array[0..0] of byte;
                              end;
         t_pt_ethernet_packet= ^t_ethernet_packet;

    const // -- 6+ 6+ 2= 14
          k_ethernet_header_size= SizeOf(t_ethernet_packet)- 1;

          // -- rfc1340
          k_PPP_IPCP_protocol = $8021;  // Internet Protocol Control Protocol
          k_PPP_CCP_protocol  = $80fd;  // Compression Control Protocol
          k_PPP_LCP_protocol  = $c021;  // PPP Link Control Protocol
          k_PPP_PAP_protocol  = $c023;  // PPP Password Authentication Protocol
          k_PPP_LQR_protocol  = $c025;  // PPP Link Quality Report
          k_PPP_CHAP_protocol = $c223;  // PPP Challenge Handshake Auth. Protocol

          k_arp_protocol= $0806;
          // -- rfc1340
          k_ip_protocol= $0800;

          k_ETHERNET_V2    = $0625;  // "old style" Ethernet length field max.value (1573)

    function f_protocol_name(p_protocol: Word): String;
    function f_protocol_family(p_protocol: Word): String;

  implementation
    uses SysUtils, u_c_display, u_display_hex_2;

    function f_protocol_family(p_protocol: Word): String;
      begin
        case p_protocol of
          k_PPP_IPCP_protocol: Result:= 'ppp';
          k_PPP_CCP_protocol: Result:= 'ppp';
          k_PPP_LCP_protocol: Result:= 'ppp';
          k_PPP_PAP_protocol: Result:= 'ppp';
          k_PPP_LQR_protocol: Result:= 'ppp';
          k_PPP_CHAP_protocol: Result:= 'ppp';

          k_arp_protocol : Result:= 'arp';
          k_ip_protocol : result:= 'ip';
          else Result:= '?_'+ IntToHex(p_protocol, 2);
        end; // case p_protocol
      end; // f_protocol_famliy

    function f_protocol_name(p_protocol: Word): String;
      begin
        case p_protocol of
          k_PPP_IPCP_protocol: Result:= 'ppp_ipcp';
          k_PPP_CCP_protocol: Result:= 'ppp_ccp';

          k_PPP_LCP_protocol: Result:= 'ppp_lcp';
          k_PPP_PAP_protocol: Result:= 'ppp_pap';
          k_PPP_LQR_protocol: Result:= 'ppp_lqr';
          k_PPP_CHAP_protocol: Result:= 'ppp_chap';
          else Result:= 'not_displayed '+ IntToHex(p_protocol, 2);
        end; // case p_protocol
      end; // f_protocol_name

    begin // u_c_ethernet_packet
    end. // u_c_ethernet_packet

et

