// 009 u_sniffer_capture_display
// 10 dec 2004

// -- (C) Felix John COLIBRI 2004
// -- documentation: http://www.felix-colibri.com

(*$r+*)

unit u_sniffer_capture_display;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, Db, DBTables, Grids, DBGrids, ComCtrls
    , u_c_packet_sniffer
  ;

type
  TForm1 = class(TForm)
    Panel4: TPanel;
    Memo1: TMemo;
    start_: TButton;
    stop_: TButton;
    sniff_panel: TPanel;
    exit_: TButton;
    log_: TCheckBox;
    procedure FormCreate(Sender: TObject);
    procedure start_Click(Sender: TObject);
    procedure stop_Click(Sender: TObject);
    procedure exit_Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
  public
  end;

var
  Form1: TForm1;

implementation
  uses u_dates, u_dir
      , u_c_log, u_c_display
      , u_c_display_packets
    ;

    {$R *.DFM}

    
    var g_c_display_packets: c_display_packets= Nil;

    procedure TForm1.FormCreate(Sender: TObject);
      begin
        initialize_display(Memo1.Lines);
        initialize_default_log;
      end; // FormCreate

    procedure TForm1.start_Click(Sender: TObject);
      var l_log_name: String;
      begin
        display('> connect');
        g_c_display_packets:= c_display_packets.create_display_packets('display_packets',
            sniff_panel);

        if log_.Checked
          then begin
              f_create_path('..\_data\');
              display(f_exe_path);
              l_log_name:= '..\_data\'+ f_now_to_string+ '_display_log.bin'
            end
          else l_log_name:= '';
        g_c_display_packets.start_capture(0, True, l_log_name, k_list_packets_true);

        display('< connect');
      end; // connect_Click

    procedure TForm1.stop_Click(Sender: TObject);
      begin
        display('> disconnect');
        if g_c_display_packets<> Nil
          then g_c_display_packets.stop_capture;
        display('< disconnect');
      end; // disconnect_Click

    procedure TForm1.exit_Click(Sender: TObject);
      begin
        Close;
      end; // exit_Click

    procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
      begin
        g_c_display_packets.Free;
      end; // FormClose

end.


